## highs 1.12.0+ds1

=== app/CMakeLists.txt ===
if(FAST_BUILD)
  if (BUILD_CXX_EXE)
    # Configure the config windows version file
    if(MSVC)
      string(REPLACE "." ","  PROJECT_RC_VERSION "${PROJECT_VERSION}")
      configure_file(${PROJECT_SOURCE_DIR}/version.rc.in
        "${HIGHS_BINARY_DIR}/version.rc" @ONLY)
      set(win_version_file ${HIGHS_BINARY_DIR}/version.rc)
    else()
      set(win_version_file)
    endif()

    add_executable(highs-bin)
    target_sources(highs-bin PRIVATE RunHighs.cpp HighsRuntimeOptions.h ${win_version_file})

    target_include_directories(highs-bin PRIVATE
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/app>
    )

    set_target_properties(highs-bin PROPERTIES POSITION_INDEPENDENT_CODE ON)

    if(UNIX)
      target_compile_options(highs-bin PUBLIC "-Wno-unused-variable")
      target_compile_options(highs-bin PUBLIC "-Wno-unused-const-variable")
    endif()

    set_target_properties(highs-bin PROPERTIES OUTPUT_NAME highs)
    set_target_properties(highs-bin PROPERTIES UNITY_BUILD OFF)

    target_compile_features(highs-bin PRIVATE cxx_std_11)
    target_link_libraries(highs-bin PRIVATE ${PROJECT_NAMESPACE}::highs)

    include(GNUInstallDirs)

    if(APPLE)
        set_target_properties(highs-bin PROPERTIES INSTALL_RPATH 
        "@loader_path/../${CMAKE_INSTALL_LIBDIR};@loader_path")
    elseif (UNIX)
        set_target_properties(highs-bin PROPERTIES INSTALL_RPATH 
        "$ORIGIN:$ORIGIN/../${CMAKE_INSTALL_LIBDIR}")
      
      # cmake_path is 3.20, leave for later.
      # cmake_path(RELATIVE_PATH CMAKE_INSTALL_FULL_LIBDIR
      #        BASE_DIRECTORY ${CMAKE_INSTALL_FULL_BINDIR}
      #        OUTPUT_VARIABLE libdir_relative_path)
      # set_target_properties(highs-bin PROPERTIES INSTALL_RPATH
      #   "$ORIGIN/${libdir_relative_path}")
    endif()

    # install the binary
    install(TARGETS highs-bin 
      EXPORT highs-targets
      RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

    if(BUILD_TESTING)
      if (APPLE)
        set(CMAKE_INSTALL_RPATH
                "@loader_path/../${CMAKE_INSTALL_LIBDIR};@loader_path")
      elseif (UNIX)
        set(CMAKE_INSTALL_RPATH "$ORIGIN/../${CMAKE_INSTALL_LIBDIR}:$ORIGIN:$ORIGIN/../lib:$ORIGIN")
      endif ()
    endif()

  endif()
else()
  # create highs binary using library without pic
  add_executable(highs)

  target_sources(highs PRIVATE RunHighs.cpp)

  if(UNIX)
    target_compile_options(highs PUBLIC "-Wno-unused-variable")
    target_compile_options(highs PUBLIC "-Wno-unused-const-variable")
  endif()

  target_link_libraries(highs libhighs)

  target_include_directories(highs PRIVATE
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/app>
  )

  set_target_properties(highs PROPERTIES UNITY_BUILD OFF)

  # install the binary
  install(TARGETS highs EXPORT highs-targets
    RUNTIME)
endif()

# Add demo to FAST_BUILD as well.
if(EMSCRIPTEN AND EMSCRIPTEN_HTML)
  set(CMAKE_EXECUTABLE_SUFFIX ".html")
  set_target_properties(highs PROPERTIES LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/highs_webdemo_shell.html)
endif()

=== examples/CMakeLists.txt ===
if(NOT BUILD_EXAMPLES)
  return()
endif()

if(BUILD_CXX_EXAMPLE)
  file(GLOB CXX_SRCS "*.cpp")
  foreach(FILE_NAME IN LISTS CXX_SRCS)
    highs_cxx_test(${FILE_NAME})
  endforeach()
endif()

# if(BUILD_PYTHON_EXAMPLE)
#   file(GLOB PYTHON_SRCS "*.py")
#   foreach(FILE_NAME IN LISTS PYTHON_SRCS)
#     add_python_example(${FILE_NAME})
#   endforeach()
# endif()

if(BUILD_CXX_EXAMPLE)
  file(GLOB C_SRCS "*_minimal.c")
  # set(C_SRCS "call_highs_from_c_minimal.c")
  foreach(FILE_NAME IN LISTS C_SRCS)
    message(${FILE_NAME})
    highs_c_test(${FILE_NAME})
  endforeach()
endif()

=== highs/CMakeLists.txt ===
if (NOT BUILD_CXX)
  return()
endif()

# Define library.
include(sources)
set(sources ${highs_sources} ${cupdlp_sources} ${ipx_sources} ${basiclu_sources})
set(headers ${highs_headers} ${cupdlp_headers} ${ipx_headers} ${basiclu_headers})

if(HIPO)
  set(sources ${sources} ${hipo_sources} ${factor_highs_sources} ${hipo_util_sources})
  set(headers ${headers} ${hipo_headers} ${factor_highs_headers} ${hipo_util_headers})
endif()

# Configure the config windows version file
if(MSVC)
  string(REPLACE "." ","  PROJECT_RC_VERSION "${PROJECT_VERSION}")
  configure_file(${PROJECT_SOURCE_DIR}/version.rc.in
    "${HIGHS_BINARY_DIR}/version.rc" @ONLY)
  set(win_version_file ${HIGHS_BINARY_DIR}/version.rc)
else()
  set(win_version_file)
endif()

# Outdated CMake approach: update in progress
if(NOT FAST_BUILD)

  add_library(libhighs ${sources} ${headers} ${win_version_file})
  target_include_directories(libhighs PRIVATE ${include_dirs})

  if(${BUILD_SHARED_LIBS})
    # put version information into shared library file
    set_target_properties(libhighs PROPERTIES
      VERSION
      ${HIGHS_VERSION_MAJOR}.${HIGHS_VERSION_MINOR}.${HIGHS_VERSION_PATCH}
      SOVERSION ${HIGHS_VERSION_MAJOR}.${HIGHS_VERSION_MINOR})
    if(MINGW)
      target_compile_definitions(libhighs PUBLIC LIBHIGHS_STATIC_DEFINE)
    endif()
  else()
    # create static highs library with pic
    set_target_properties(libhighs PROPERTIES
      POSITION_INDEPENDENT_CODE on)
    target_compile_definitions(libhighs PUBLIC LIBHIGHS_STATIC_DEFINE)
  endif()

  # on UNIX system the 'lib' prefix is automatically added
  set_target_properties(libhighs PROPERTIES
    OUTPUT_NAME "highs"
    PDB_NAME "libhighs"
  )

  if(ZLIB AND ZLIB_FOUND)
    target_link_libraries(libhighs ZLIB::ZLIB)
    set(CONF_DEPENDENCIES "include(CMakeFindDependencyMacro)\nfind_dependency(ZLIB)")
  endif()

  # set the install rpath to the installed destination
  if(APPLE)
      set_target_properties(libhighs PROPERTIES INSTALL_RPATH "@loader_path")
  elseif (UNIX)
      set_target_properties(libhighs PROPERTIES INSTALL_RPATH "$ORIGIN")
  endif()

  # install the header files of highs
  foreach(file ${headers})
    get_filename_component(dir ${file} DIRECTORY)

    if(NOT dir STREQUAL "")
      string(REPLACE ../extern/ "" dir ${dir})
    endif()

    install(FILES ${file} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/highs/${dir})
  endforeach()
  install(FILES ${HIGHS_BINARY_DIR}/HConfig.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/highs)

  if(UNIX)
    # target_compile_options(libhighs PRIVATE "-Wno-defaulted-function-deleted")
    # target_compile_options(libhighs PRIVATE "-Wno-return-type-c-linkage")
    target_compile_options(libhighs PRIVATE "-Wno-return-type" "-Wno-switch")

    target_compile_options(libhighs PRIVATE "-Wno-unused-variable")
    target_compile_options(libhighs PRIVATE "-Wno-unused-const-variable")

    # target_compile_options(libhighs PRIVATE "-Wno-sign-compare")
    # target_compile_options(libhighs PRIVATE "-Wno-logical-op-parentheses")

    # target_compile_options(libipx PRIVATE "-Wno-defaulted-function-deleted")
    # target_compile_options(libipx PRIVATE "-Wno-return-type-c-linkage")
    # target_compile_options(libipx PRIVATE "-Wno-return-type" "-Wno-switch")

    # target_compile_options(libipx PRIVATE "-Wno-sign-compare")
    # target_compile_options(libipx PRIVATE "-Wno-logical-op-parentheses")
  endif()

  install(TARGETS libhighs EXPORT highs-targets
    LIBRARY
    ARCHIVE
    RUNTIME
    INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/highs)

  # Add library targets to the build-tree export set
  export(TARGETS libhighs
    FILE "${HIGHS_BINARY_DIR}/highs-targets.cmake")

  # Configure the config file for the build tree:
  # Either list all the highs/* directories here, or put explicit paths in all the
  # include statements.
  # M reckons that the latter is more transparent, and I'm inclined to agree.
  set(CONF_INCLUDE_DIRS "${PROJECT_SOURCE_DIR}/highs" "${HIGHS_BINARY_DIR}")
  configure_file(${PROJECT_SOURCE_DIR}/cmake/highs-config.cmake.in
    "${HIGHS_BINARY_DIR}/highs-config.cmake" @ONLY)

  # Configure the config file for the install
  set(CONF_INCLUDE_DIRS "\${CMAKE_CURRENT_LIST_DIR}/../../../${CMAKE_INSTALL_INCLUDEDIR}/highs")
  configure_file(${PROJECT_SOURCE_DIR}/cmake/highs-config.cmake.in
    "${HIGHS_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/highs-config.cmake" @ONLY)

  # Configure the pkg-config file for the install
  configure_file(${PROJECT_SOURCE_DIR}/highs.pc.in
    "${HIGHS_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/highs.pc" @ONLY)

  # Install the targets of the highs export group, the config file so that other
  # cmake-projects can link easily against highs, and the pkg-config flie so that
  # other projects can easily build against highs
  install(EXPORT highs-targets FILE highs-targets.cmake DESTINATION
    ${CMAKE_INSTALL_LIBDIR}/cmake/highs)
  install(FILES "${HIGHS_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/highs-config.cmake"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/highs)
  install(FILES "${HIGHS_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/highs.pc"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

else()
  # FAST_BUILD is set to on.
  # At the moment used only for gradually updating the CMake targets build and
  # install / export.
  # Define library in modern CMake using target_*()
  # No interfaces (apart from c); No ipx; New (short) ctest instances.
  add_library(highs)

  add_library(${PROJECT_NAMESPACE}::highs ALIAS highs)

  if(${BUILD_SHARED_LIBS})
    # put version information into shared library file
    set_target_properties(highs PROPERTIES
      VERSION
      ${HIGHS_VERSION_MAJOR}.${HIGHS_VERSION_MINOR}.${HIGHS_VERSION_PATCH}
      SOVERSION ${HIGHS_VERSION_MAJOR}.${HIGHS_VERSION_MINOR})
  endif()

  set_target_properties(highs PROPERTIES POSITION_INDEPENDENT_CODE ON)

  if(APPLE)
      set_target_properties(highs PROPERTIES INSTALL_RPATH "@loader_path")
  elseif (UNIX)
      set_target_properties(highs PROPERTIES INSTALL_RPATH "$ORIGIN")
  endif()


  target_sources(highs PRIVATE ${sources} ${headers} ${win_version_file})

  # Optional Cuda
  if (CUPDLP_GPU)

    target_include_directories(highs PUBLIC "$<BUILD_INTERFACE:${CMAKE_CUDA_PATH}/include>")
    set(CUPDLP_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/highs/pdlp/cupdlp/")

    add_subdirectory(pdlp/cupdlp/cuda)

    if (WIN32)
      target_link_libraries(highs PRIVATE cudalin ${CUDA_LIBRARY})
    else()
      target_link_libraries(highs PRIVATE cudalin ${CUDA_LIBRARY} m)
    endif()

    set_target_properties(highs PROPERTIES CUDA_SEPARABLE_COMPILATION ON)

  endif()

  target_include_directories(highs PRIVATE ${include_dirs})

  # Optional HIPO
  if (HIPO)

    target_include_directories(highs PRIVATE
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/highs/hipo>
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/highs/hipo/auxiliary>
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/highs/hipo/factorhighs>
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/highs/hipo/ipm>
    )

    if (NOT USE_CMAKE_FIND_BLAS)
      if(APPLE)
          target_link_libraries(highs PRIVATE "-framework Accelerate")
          target_compile_definitions(highs PRIVATE HIPO_USES_APPLE_BLAS)
      elseif(WIN32)
        if(TARGET OpenBLAS::OpenBLAS)
            target_compile_definitions(highs PRIVATE HIPO_USES_OPENBLAS)
            target_link_libraries(highs PRIVATE OpenBLAS::OpenBLAS)
        elseif(OPENBLAS_LIB)
            target_compile_definitions(highs PRIVATE HIPO_USES_OPENBLAS)
            message(STATUS "Linking against OpenBLAS via raw library: ${OPENBLAS_LIB}")
            target_link_libraries(highs PRIVATE ${OPENBLAS_LIB})
            target_include_directories(highs PRIVATE ${OPENBLAS_INCLUDE_DIR})
        else()
            message(FATAL_ERROR "OpenBLAS not found on Windows.")
        endif()

        target_compile_definitions(highs PRIVATE HIPO_USES_OPENBLAS)
      else()
          # LINUX
          if(BLAS_LIB)
              target_link_libraries(highs PRIVATE "${BLAS_LIB}")
          elseif(OPENBLAS_LIB)
              target_link_libraries(highs PRIVATE "${OPENBLAS_LIB}")
              target_compile_definitions(highs PRIVATE HIPO_USES_OPENBLAS)
          else()
              message(FATAL_ERROR "No BLAS library available")
          endif(BLAS_LIB)
      endif(APPLE)
    else()
      target_link_libraries(highs PRIVATE BLAS::BLAS)

      string(TOLOWER "${BLAS_LIBRARIES}" blas_lower)
      if(blas_lower MATCHES "openblas")
          target_compile_definitions(highs PRIVATE HIPO_USES_OPENBLAS)
      elseif(blas_lower MATCHES "accelerate")
        target_compile_definitions(highs PRIVATE HIPO_USES_APPLE_BLAS)
      endif()
    endif()

    if(metis_FOUND)
      target_link_libraries(highs PRIVATE metis)
    else()
      target_include_directories(highs PRIVATE "${METIS_PATH}")
      target_link_libraries(highs PRIVATE "${METIS_LIB}")
    endif()

    if (NOT (GKLIB_ROOT STREQUAL ""))
      if(GKlib_FOUND)
        target_link_libraries(highs PRIVATE GKlib::GKlib)
      else()
        target_include_directories(highs PRIVATE "${GKLIB_PATH}")
        target_link_libraries(highs PRIVATE "${GKLIB_LIB}")
      endif()
    endif()
  endif()

  if(MSVC)
    list(APPEND highs_compile_opts
      "/bigobj" # Allow big object
      "/DNOMINMAX"
      "/DWIN32_LEAN_AND_MEAN=1"
      "/D_CRT_SECURE_NO_WARNINGS"
      "/D_CRT_SECURE_NO_DEPRECATE"
      "/MP" # Build with multiple processes
      "/Zc:preprocessor" # Enable preprocessor conformance mode
      "/fp:precise"
      )
    if (CMAKE_BUILD_TYPE STREQUAL Release)
      list(APPEND highs_compile_opts
        "/DNDEBUG")
    endif()
    # MSVC warning suppressions
    list(APPEND highs_compile_opts
      "/wd4005" # 'macro-redefinition'
      "/wd4018" # 'expression' : signed/unsigned mismatch
      "/wd4065" # switch statement contains 'default' but no 'case' labels
      "/wd4068" # 'unknown pragma'
      "/wd4101" # 'identifier' : unreferenced local variable
      "/wd4146" # unary minus operator applied to unsigned type, result still unsigned
      "/wd4200" # nonstandard extension used : zero-sized array in struct/union
      "/wd4244" # 'conversion' conversion from 'type1' to 'type2', possible loss of data
      "/wd4251" # 'identifier' : class 'type' needs to have dll-interface to be used by clients of class 'type2'
      "/wd4267" # 'var' : conversion from 'size_t' to 'type', possible loss of data
      "/wd4305" # 'identifier' : truncation from 'type1' to 'type2'
      "/wd4307" # 'operator' : integral constant overflow
      "/wd4309" # 'conversion' : truncation of constant value
      "/wd4334" # 'operator' : result of 32-bit shift implicitly converted to 64 bits (was 64-bit shift intended?)
      "/wd4355" # 'this' : used in base member initializer list
      "/wd4477" # 'fwprintf' : format string '%s' requires an argument of type 'wchar_t *'
      "/wd4506" # no definition for inline function 'function'
      "/wd4715" # function' : not all control paths return a value
      "/wd4800" # 'type' : forcing value to bool 'true' or 'false' (performance warning)
      "/wd4996" # The compiler encountered a deprecated declaration.
      )
    target_compile_options(highs PRIVATE ${highs_compile_opts})
  # else()
  #   list(APPEND highs_compile_opts "-fwrapv")
  endif()


  if(ZLIB AND ZLIB_FOUND)
    target_include_directories(highs PRIVATE
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/extern/zstr>
    )
    target_link_libraries(highs PRIVATE ZLIB::ZLIB)
  endif()

  # install the header files of highs
  foreach(file ${headers})
    get_filename_component(dir ${file} DIRECTORY)

    if(NOT dir STREQUAL "")
      string(REPLACE ../extern/ "" dir ${dir})
    endif()

    install(FILES ${file} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/highs/${dir})
  endforeach()
  install(FILES ${HIGHS_BINARY_DIR}/HConfig.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/highs)

  # target_compile_options(highs PRIVATE "-Wall")

=== highs/pdlp/cupdlp/cuda/CMakeLists.txt ===
enable_language(CXX CUDA)

add_library(cudalin SHARED
       ${CUPDLP_INCLUDE_DIR}/cuda/cupdlp_cuda_kernels.cu
       ${CUPDLP_INCLUDE_DIR}/cuda/cupdlp_cuda_kernels.cuh
       ${CUPDLP_INCLUDE_DIR}/cuda/cupdlp_cudalinalg.cuh
       ${CUPDLP_INCLUDE_DIR}/cuda/cupdlp_cudalinalg.cu
)
set_target_properties(cudalin PROPERTIES CUDA_SEPARABLE_COMPILATION ON)

# set_target_properties(cudalin PROPERTIES CUDA_ARCHITECTURES native)

target_include_directories(cudalin PUBLIC "$<BUILD_INTERFACE:${CMAKE_CUDA_PATH}/include>")

if (WIN32)
  target_link_libraries(cudalin ${CUDA_LIBRARY})
else()
  # target_compile_definitions(cudalin
  #     PUBLIC
  #     # If the debug configuration pass the DEBUG define to the compiler
  #     $<$<CONFIG:Debug>:-DCUPDLP_DEBUG=1>
  #   )
  target_link_libraries(cudalin ${CUDA_LIBRARY} m)
endif()

# add a test
add_executable(testcudalin test_cuda_linalg.c)
add_executable(testcublas test_cublas.c)

set_target_properties(testcudalin PROPERTIES CUDA_SEPARABLE_COMPILATION ON)
#target_include_directories(cudalinalg PRIVATE ${CUPDLP_INCLUDE_DIR}/cuda)
target_link_libraries(testcudalin PRIVATE cudalin ${CUDA_LIBRARY})

set_target_properties(testcublas PROPERTIES CUDA_SEPARABLE_COMPILATION ON)
target_link_libraries(testcublas PRIVATE cudalin ${CUDA_LIBRARY})

=== debian/changelog ===
highs (1.12.0+ds1-1) unstable; urgency=medium

  * d/rules: do not build tests except on amd64.
  * d/copyright: exclude vendored CLI11 from src, update some comments.
    + Re-packed as new upstream version 1.12.0+ds1.
    + d/patches: use headers from libcli11-dev instead of vendoring.
    + d/control: add libcli11-dev in B-D.

 -- Shengqi Chen <harry@debian.org>  Mon, 10 Nov 2025 10:52:38 +0800

=== debian/control ===
Source: highs
Section: science
Priority: optional
Standards-Version: 4.7.2
Maintainer: Debian Science Maintainers <debian-science-maintainers@alioth-lists.debian.net>
Uploaders: Shengqi Chen <harry@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-sequence-python3,
               help2man,
               libz-dev,
               libcli11-dev,
               libcatch2-dev <!nocheck>,
               ninja-build,
               pybuild-plugin-pyproject,
               python3-dev,
               python3-numpy,
               python3-pybind11,
               python3-pytest <!nocheck>,
               python3-scikit-build-core
Homepage: https://highs.dev/
Vcs-Git: https://salsa.debian.org/science-team/highs.git
Vcs-Browser: https://salsa.debian.org/science-team/highs
Rules-Requires-Root: no

Package: libhighs1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: highs
Description: High performance linear optimization software (shared library)
 HiGHS is a high performance serial and parallel solver for large scale
 sparse linear optimization problems, including linear programming (LP)
 problems, convex quadratic programming (QP) problems, and mixed integer
 programming (MIP) problems.
 .
 This package contains the libhighs1 shared library.

Package: python3-highspy
Section: python
Architecture: any
Depends: libhighs1 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: High performance linear optimization software (Python library)
 HiGHS is a high performance serial and parallel solver for large scale
 sparse linear optimization problems, including linear programming (LP)
 problems, convex quadratic programming (QP) problems, and mixed integer
 programming (MIP) problems.
 .
 This package contains the Python library for HiGHS.

Package: libhighs-dev
Section: libdevel
Architecture: any
Depends: libhighs1 (= ${binary:Version}), ${misc:Depends}
Description: High performance linear optimization software (development files)
 HiGHS is a high performance serial and parallel solver for large scale
 sparse linear optimization problems, including linear programming (LP)
 problems, convex quadratic programming (QP) problems, and mixed integer
 programming (MIP) problems.
 .
 This package contains the development files for libhighs.

Package: highs
Architecture: any
Depends: libhighs1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: High performance linear optimization software
 HiGHS is a high performance serial and parallel solver for large scale
 sparse linear optimization problems, including linear programming (LP)
 problems, convex quadratic programming (QP) problems, and mixed integer
 programming (MIP) problems.
 .
 This package contains the HiGHS solver.

=== debian/rules ===
#!/usr/bin/make -f

SOVERSION=1
FULLVERSION=1.12.0

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

# these files are to be moved out of python3-highspy package after built
TARGET_PREFIX = debian/tmp/usr
TARGET_LIBDIR = $(TARGET_PREFIX)/lib/$(DEB_HOST_MULTIARCH)
SYSTEM_LIBDIR = usr/lib/$(DEB_HOST_MULTIARCH)

# we need a hardcoded path to find in dh_auto_test
BUILDDIR = /tmp/highs-build
BUILD_LIBDIR = $(BUILDDIR)/$(TARGET_LIBDIR)

CMAKE_TESTS = OFF
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
# some c++ tests use regex to match FP numbers precisely,
# thus are only reproducible on amd64 ISAs
ifeq ($(DEB_HOST_ARCH_CPU),amd64)
CMAKE_TESTS = ON
endif
endif

SKBUILD_ARGS = \
	-C skbuild.build-dir=$(BUILDDIR) \
	-C skbuild.ninja.version=">=1.5" \
	-C skbuild.build.verbose=true \
	-C skbuild.install.strip=false \
	-C skbuild.cmake.build-type=None \
	-C skbuild.cmake.args=-DCMAKE_C_FLAGS="$(CFLAGS) $(CPPFLAGS)" \
	-C skbuild.cmake.args=-DCMAKE_CXX_FLAGS="$(CXXFLAGS) $(CPPFLAGS)" \
	-C skbuild.cmake.args=-DCMAKE_EXE_LINKER_FLAGS="$(LDFLAGS)" \
	-C skbuild.cmake.args=-DPYTHON_BUILD_SETUP=ON \
	-C skbuild.cmake.args=-DFAST_BUILD=ON \
	-C skbuild.cmake.args=-DBUILD_SHARED_LIBS=ON \
	-C skbuild.cmake.args=-DCMAKE_INSTALL_PREFIX=/usr \
	-C skbuild.cmake.args=-DCMAKE_INSTALL_LIBDIR=$(TARGET_LIBDIR) \
	-C skbuild.cmake.args=-DCMAKE_INSTALL_INCLUDEDIR=$(TARGET_PREFIX)/include

ifeq ($(CMAKE_TESTS),ON)
	SKBUILD_ARGS += -C skbuild.cmake.args=-DALL_TESTS=ON
endif

# config pybuild and skbuild
export PYBUILD_NAME = highspy
export PYBUILD_SYSTEM = pyproject
export PYBUILD_BUILD_ARGS_$(shell py3versions -d) = $(SKBUILD_ARGS)

PY_DEST_DIR=debian/python3-highspy/usr/lib/$(shell py3versions -d)/dist-packages

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq ($(CMAKE_TESTS),ON)
	cd $(BUILDDIR) && ctest --output-on-failure
else
# run only python tests on non-amd64 arch
# may be flaky on hurd (issues in numpy?)
ifneq (,$(filter $(DEB_HOST_ARCH_OS),linux))
	# set LD_LIBRARY_PATH to find compiled _core.so and libhighs.so
	LD_LIBRARY_PATH=$(shell realpath $(BUILD_LIBDIR)) dh_auto_test
endif # filter linux
endif # filter amd64
endif # nocheck

execute_after_dh_auto_install:
	# move files out of python3-highspy package
	mkdir -p debian/tmp/
	mv $(PY_DEST_DIR)/$(TARGET_PREFIX) $(TARGET_PREFIX)
	mv $(PY_DEST_DIR)/bin $(TARGET_PREFIX)/bin # CMAKE_INSTALL_BINDIR does not work, I don't know why
	rm -rf $(PY_DEST_DIR)/debian
	# remove hardcoded build path
	sed -i 's|#define HIGHS_DIR .*|#define HIGHS_DIR "/usr"|' $(TARGET_PREFIX)/include/highs/HConfig.h
	# generate manpage from help
	LD_LIBRARY_PATH=$(TARGET_LIBDIR) help2man --version-string=$(DEB_VERSION_UPSTREAM) --name="HiGHS -- High performance linear optimization software" -N -o highs.1 $(TARGET_PREFIX)/bin/highs

execute_after_dh_install:
	# replace duplicated .so files (copied when building wheels) with symlinks
	dh_link -p libhighs$(SOVERSION) $(SYSTEM_LIBDIR)/libhighs.so.$(FULLVERSION) $(SYSTEM_LIBDIR)/libhighs.so.$(SOVERSION)
	dh_link -p libhighs-dev $(SYSTEM_LIBDIR)/libhighs.so.$(SOVERSION) $(SYSTEM_LIBDIR)/libhighs.so

=== debian/watch ===
Version: 5
Template: GitHub
Owner: ERGO-Code
Project: HiGHS
RepackSuffix: +ds
